#import "/src/cetz.typ": draw

#import "/src/core/utils.typ": normalize-measure, normalize-units

#let name = "control"

#let render(x, y, p, bottom) = {
  let m = normalize-measure(p.display-name)
  let style = p.resolved-style
  let size = normalize-units(style.size)
  let spacing = normalize-units(style.spacing)
  let r = size / 2
  let y0 = if bottom {
    y - m.height - spacing
  } else {
    y + m.height + size + spacing
  }

  draw.circle(
    (x, y0 - r),
    radius: r,
    fill: style.fill,
    stroke: style.stroke
  )
  let s = stroke(style.stroke)
  draw.mark(
    (x, y0), (x - r / 2, y0),
    symbol: "stealth",
    fill: s.paint,
    stroke: s.paint
  )
  draw.content(
    (x, y),
    p.display-name,
    anchor: if bottom {"north"} else {"base"}
  )
}

#let get-size(par) = {
  let m = normalize-measure(par.display-name)

  let size = normalize-units(par.resolved-style.size)
  let spacing = normalize-units(par.resolved-style.spacing)

  return (
    width: calc.max(m.width, size),
    height: size + spacing + m.height
  )
}

#let default-style = (
  size: 20pt,
  spacing: 5pt
)